/**
 * 
 */
package de.gilles.projects.switchyard;

import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;

import javax.xml.XMLConstants;
import javax.xml.namespace.NamespaceContext;

/**
 * @author gilles
 *
 */
public class SwitchyardNamespaceContext implements NamespaceContext {
	
	private static final String SWITCHYARD_NAMESPACE = "urn:gillesswitchyard:services:1.0";
	private static final String SWITCHYARD_PREFIX = "urn";

	/**
	 * @see javax.xml.namespace.NamespaceContext#getNamespaceURI(java.lang.String)
	 */
	@Override
	public String getNamespaceURI(String prefix) {
		if(prefix == null){
			throw new IllegalArgumentException("No prefix provided!");
		}else if(prefix.equals(XMLConstants.DEFAULT_NS_PREFIX)){
			return SWITCHYARD_NAMESPACE;
		} else if(prefix.equals(SWITCHYARD_PREFIX)){
			return SWITCHYARD_NAMESPACE;
		}else{
			return XMLConstants.NULL_NS_URI;
		}
	}

	/**
	 * @see javax.xml.namespace.NamespaceContext#getPrefix(java.lang.String)
	 */
	@Override
	public String getPrefix(String namespaceURI) {
		if(namespaceURI == null){
			throw new IllegalArgumentException("No namespaceURI provided!");
		}else if(namespaceURI.equals(SWITCHYARD_NAMESPACE)){	
			return SWITCHYARD_PREFIX;
		}else{
			return XMLConstants.DEFAULT_NS_PREFIX;
		}
	}

	/**
	 * @see javax.xml.namespace.NamespaceContext#getPrefixes(java.lang.String)
	 */
	@SuppressWarnings("rawtypes")
	@Override
	public Iterator getPrefixes(String namespaceURI) {
		if(namespaceURI == null){
			throw new IllegalArgumentException("No namespaceURI provided!");
		}else if(namespaceURI.equals(SWITCHYARD_NAMESPACE)){	
			return Arrays.asList(SWITCHYARD_PREFIX).iterator();
		}else{
			return Collections.EMPTY_LIST.iterator();
		}
	}

}
