package de.gilles.projects.switchyard;

import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactoryConfigurationException;

import junit.framework.Assert;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

public class SwitchyardTransformerTest {
	static final String GILLES_NAME = "Gilles Dupont Tagne Tagne";
	String sayhello;
	SwitchyardTransformer transformer;

	@Before
	public void setUp() throws Exception {
		transformer = new SwitchyardTransformer();
		sayhello = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><urn:sayHello xmlns:urn=\"urn:gillesswitchyard:services:1.0\">"
				+ "<!--Optional:-->"
				+ "<urn:name>"+ GILLES_NAME +"</urn:name>"
				+ "</urn:sayHello>";
	}

	@After
	public void tearDown() throws Exception {
		sayhello = null;
		transformer = null;
	}

	@Test
	public void testTransformSayHello() throws XPathExpressionException, XPathFactoryConfigurationException {
		String transformSayHello = transformer.transformSayHello(sayhello);
		System.out.println("sayHello: " + transformSayHello);
		Assert.assertEquals(GILLES_NAME, transformSayHello);
	}


}
